(******************************************************************************
 ******************************************************************************
 ***                                                                        ***
 ***             Copyright (c) 1995 - 2003 by -=Assarbad [GoP]=-            ***
 ***      ____________                 ___________                          ***
 ***     /\   ________\               /\   _____  \     UIN: 281645         ***
 ***    /  \  \       /    __________/  \  \    \  \    AIM: nixlosheute    ***
 ***    \   \  \   __/___ /\   _____  \  \  \____\  \        nixahnungnicht ***
 ***     \   \  \ /\___  \  \  \    \  \  \   _______\                      ***
 ***      \   \  \ /   \  \  \  \    \  \  \  \      /  Assarbad@gmx.info   ***
 ***       \   \  \_____\  \  \  \____\  \  \  \____/                       ***
 ***        \   \___________\  \__________\  \__\                           ***
 ***         \  /           /  /          /  /  /                           ***
 ***          \/___________/ \/__________/ \/__/                            ***
 ***                                                                        ***
 ***              May the source be with you, stranger ... ;)               ***
 ***    Snizhok, eto ne tolko fruktovij kefir, snizhok, eto stil zhizn.     ***
 ***                                                                        ***
 *** Greets from -=Assarbad=- fly to YOU =)                                 ***
 *** Special greets fly 2 Nico, Casper, SA, Pizza, Navarion, Eugen, Zhenja, ***
 *** Xandros etc pp.                                                        ***
 ***                                                                        ***
 ***               [for questions/proposals drop me a mail]                 ***
 *********************************************************** ASCII by Assa ****
 ******************************************************************************)

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

                                 _\\|//_
                                (` * * ')
 ______________________________ooO_(_)_Ooo_____________________________________
 LEGAL STUFF:
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

 Copyright (c) 1995-2003, -=Assarbad=- ["copyright holder(s)"]
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.
 3. The name(s) of the copyright holder(s) may not be used to endorse or
    promote products derived from this software without specific prior written
    permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
                             .oooO     Oooo.
 ____________________________(   )_____(   )___________________________________
                              \ (       ) /
                               \_)     (_/
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
{
Remarks:
Sorry, this is the work of maybe 2 hours at all ... don't expect too
much. But it should be bug-free and so on.
If you want to schedule the program, test the script before. In this
case the /nodel parameter may prove useful ;)

History

1.03
- allowing to save all event log files at once (using the * switch)
- re-arranged the code to be better re-usable.
1.02
- corrected registry path
1.01
- added all the missing stuff:
    * checks registry wether the given eventlog name is existant
    * added /nodel
    * changed and fixed minor things
1.00
- working example, no error checking, no check if log exists before calling the
  functions.
}

program save_el;

{$APPTYPE CONSOLE}
uses
  Windows;

{$INCLUDE .\Include\FormatString.pas}
{$INCLUDE .\Include\FileExists.pas}
{$INCLUDE .\Include\GetErrorMessage.pas}
{$INCLUDE .\Include\ConsoleHlp.pas}

const
  servicekey = 'SYSTEM\CurrentControlSet\Services\Eventlog';
  format_fname = '%s_%4.4d-%2.2d-%2.2d@%2.2d_%2.2d_%2.2d.evt';
  savedel = 'Saving "%s" and clearing the event log contents ...';
  savenodel = 'Saving "%s" without clearing anything ...';
  nodel_text = '/nodel';
  bkpall_text = '*';
  ver = '[1.03]';

procedure ShowCopyright();
begin
  SetTextAttribute(FOREGROUND_GREEN or FOREGROUND_INTENSITY);
  writeln('-------------------------------------------------------------------------------');
  writeln('            Save Eventlog - (c) 2002-2003 by -=Assarbad=- ', ver);
  writeln('-------------------------------------------------------------------------------');
  writeln;
  SetTextAttribute(FOREGROUND_BLUE or FOREGROUND_GREEN or FOREGROUND_RED);
end;

procedure ShowSyntax();
begin
  SetTextAttribute(FOREGROUND_RED or FOREGROUND_INTENSITY);
  writeln('Syntax:');
  writeln('-------');
  SetTextAttribute(FOREGROUND_BLUE or FOREGROUND_GREEN or FOREGROUND_RED);
  writeln('     save_el NameOfLog|* [DestinationPath] [/nodel]');
  SetTextAttribute(FOREGROUND_BLUE or FOREGROUND_INTENSITY);
  writeln('     NameOfLog');
  SetTextAttribute(FOREGROUND_BLUE or FOREGROUND_GREEN or FOREGROUND_RED);
  writeln('          Will backup the eventlog with the respective name.');
  SetTextAttribute(FOREGROUND_BLUE or FOREGROUND_INTENSITY);
  writeln('     *');
  SetTextAttribute(FOREGROUND_BLUE or FOREGROUND_GREEN or FOREGROUND_RED);
  writeln('          Will backup all eventlogs found!');
  SetTextAttribute(FOREGROUND_BLUE or FOREGROUND_INTENSITY);
  writeln('     /nodel');
  SetTextAttribute(FOREGROUND_BLUE or FOREGROUND_GREEN or FOREGROUND_RED);
  writeln('          Will not clear the respective log file after backup.');
  writeln;
  SetTextAttribute(FOREGROUND_RED or FOREGROUND_INTENSITY);
  writeln('Examples for the syntax:');
  writeln('------------------------');
  SetTextAttribute(FOREGROUND_BLUE or FOREGROUND_GREEN or FOREGROUND_RED);
  writeln('     save_el *');
  writeln('     save_el Application D:\LogFiles');
  writeln('     save_el "Directory Service" "D:\Log Files"');
  writeln;
  writeln('The files are named according to current time. Existing are overwritten.');
  writeln('Note, that if some name contains spaces you _have_ to use quotes.');
  writeln('Have fun ... [http://assarbad.net]');
  writeln;
  SetTextAttribute(FOREGROUND_BLUE or FOREGROUND_GREEN or FOREGROUND_RED or FOREGROUND_INTENSITY);
  writeln('-------------------------------------------------------------------------------');
  writeln('            Under BSDL, whereas "copyright holder" is "-=Assarbad=-"');
  writeln('-------------------------------------------------------------------------------');
  SetTextAttribute(FOREGROUND_BLUE or FOREGROUND_GREEN or FOREGROUND_RED);
end;

procedure OutErr(err: Integer);
begin
  case err of
    ERROR_SUCCESS:
    begin
      Write('Success: ');
      Writeln(GetErrorMessage(err));
    end;
  else
    begin
    Write('Error: ');
    Writeln(GetErrorMessage(err));
    end;
  end;
end;

function SaveEventLog(elname: string; targetpath: string): Longint;
(*
- elname is the name of the eventlog as given in the eventlog service key
- targetpath is the target path where to save the evenlog (with or without
  trailing backslash)
*)
var
  fname, keyname: string;
  hReg: HKEY;
  hLog: THandle;
  st: TSystemTime;
begin
  keyname := servicekey + '\' + elname;
  result := RegOpenKey(HKEY_LOCAL_MACHINE, @keyname[1], hReg);
  RegCloseKey(hReg);
  if result = ERROR_SUCCESS then
    begin
      hLog := OpenEventLog(nil, @elname[1]);
      if hLog <> 0 then
      try
        GetSystemTime(st);
        fname := Format(format_fname, [elname, st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute, st.wSecond]);
        while pos(#32, fname) > 0 do
          fname[pos(#32, fname)] := '_';
        if targetpath[length(targetpath)] <> '\' then
          targetpath := targetpath + '\';
        fname := targetpath + fname;
        result := Integer(BackupEventlog(hLog, @fname[1]));
      finally
        CloseEventLog(hLog);
      end;
    end
end;

function SaveAndDeleteEventLog(elname: string; targetpath: string): Longint;
(*
- elname is the name of the eventlog as given in the eventlog service key
- targetpath is the target path where to save the evenlog (with or without
  trailing backslash)
*)
var
  fname, keyname: string;
  hReg: HKEY;
  hLog: THandle;
  st: TSystemTime;
begin
  keyname := servicekey + '\' + elname;
  result := RegOpenKey(HKEY_LOCAL_MACHINE, @keyname[1], hReg);
  RegCloseKey(hReg);
  if result = ERROR_SUCCESS then
    begin
      hLog := OpenEventLog(nil, @elname[1]);
      if hLog <> 0 then
      try
        GetSystemTime(st);
        fname := Format(format_fname, [elname, st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute, st.wSecond]);
        while pos(#32, fname) > 0 do
          fname[pos(#32, fname)] := '_';
        if targetpath[length(targetpath)] <> '\' then
          targetpath := targetpath + '\';
        fname := targetpath + fname;
        result := Integer(ClearEventLog(hLog, @fname[1]));
      finally
        CloseEventLog(hLog);
      end;
    end
end;

var
  idx, i: LongInt;
  param1, param2: string;
  nodel: boolean;
  namebuf: array[0..MAX_PATH] of char;
  hReg: HKEY;
  bufsize, err: DWORD;
  ft: FILETIME;
begin
  ShowCopyright;
  param1 := paramstr(1);
  nodel := false;
// =======================================================================/nodel
  for i := 1 to paramcount do
    if lstrcmpi(@paramstr(i)[1], @nodel_text[1]) = 0 then
      begin
        nodel := true;
        break;
      end;
// ========================================================================Pause
  case lstrcmpi(@paramstr(2)[1], @nodel_text[1]) of
    0: param2 := ''; // this is the /nodel parameter
  else
    param2 := paramstr(2); // here it is the path
  end;
// ==================================================================Target Path
  if param2 = '' then // if empty target path, use current directory
    begin
      setlength(param2, MAX_PATH + 1);
      GetCurrentDirectory(MAX_PATH, @param2[1]);
      setlength(param2, lstrlen(@param2[1]));
    end;
// =========================================================================MAIN
  if param1 <> '' then
    case param1 = bkpall_text of
      True: // This will backup all eventlogs ...
        begin
          err := RegOpenKey(HKEY_LOCAL_MACHINE, @servicekey[1], hReg);
          if err = ERROR_SUCCESS then
          try
            bufsize := sizeof(namebuf);
            ZeroMemory(@namebuf, bufsize);
            idx := 0;
            while RegEnumKeyEx(hReg, idx, @namebuf, bufsize, nil, nil, nil, @ft) = ERROR_SUCCESS do
              begin
                SetString(param1, PChar(@namebuf), lstrlen(@namebuf));
                case nodel of
                  True:
                    begin
                      Writeln(Format(savenodel, [param1]));
                      SaveEventLog(param1, param2);
                    end;
                else
                  begin
                    Writeln(Format(savedel, [param1]));
                    SaveAndDeleteEventLog(param1, param2);
                  end;
                end;
                bufsize := sizeof(namebuf);
                ZeroMemory(@namebuf, bufsize);
                inc(idx);
                if GetLastError <> ERROR_SUCCESS then
                  OutErr(GetLastError);
              end;
          finally
            RegCloseKey(hReg);
          end
          else
            OutErr(err);
        end
    else // This will only backup a specific eventlog
      begin
        case nodel of
          True:
            begin
              Writeln(Format(savenodel, [param1]));
              SaveEventLog(param1, param2);
            end;
        else
          begin
            Writeln(Format(savedel, [param1]));
            SaveAndDeleteEventLog(param1, param2);
          end;
        end;
        if GetLastError <> ERROR_SUCCESS then
          OutErr(GetLastError);
      end;
    end
    else
    ShowSyntax;
end.

